package drawing;

import java.awt.Color;
import java.io.Serializable;

/**
 * Definicja wygldu linii (gruboci i koloru).
 *
 */

public class Pen implements Serializable{
	/**
	 * Kolor krzywej.
	 */
	private Color color = new Color(0,0,0);
	/**
	 * Grubo krzywej.
	 */
	private int lineWidth = 2;
	
	/**
	 * Daj kolor.
	 */
	public Color getColor() {
		return color;
	}

	/**
	 * Ustaw kolor
	 * @param color Nowy kolor.
	 */
	public void setColor(Color color) {
		this.color = color;
	}

	/** 
	 * Ustw grubo linii.
	 * @return Grubo linii.
	 */
	public int getLineWidth() {
		return lineWidth;
	}

	/**
	 * Ustaw grubo krzywej.
	 * @param lineWidth Grubo linii.
	 */
	public void setLineWidth(int lineWidth) {
		this.lineWidth = lineWidth;
	}

	/**
	 * Konstruktor.
	 *
	 */
	public Pen() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/** 
	 * Gboka kopia pisaka, wraz z kolorem.
	 * @return Gboka kopia pisaka.
	 */
	public Pen deepCopy(){
		Pen p = new Pen();
		p.setLineWidth(lineWidth);
		p.setColor(new Color(color.getRed(), color.getGreen(), color.getBlue()));
		return p;
	}

}
