package drawingclient;

import java.awt.Dimension;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.util.StringTokenizer;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.WindowConstants;

import drawingserver.DrawingServer;

/**
 * Klasa do uruchamiania klienta w formie aplikacji. Jako argumenty przyjmuje
 * adres hosta i port na ktrym znajduje si rejestr
 * RMI.
 */
public class DrawingClientLauncher {

	/**
	 * Konstruktor.
	 *
	 */
	public DrawingClientLauncher() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * 
	 * @param argv Pierwszy argument to adres hosta, drugi to port.   
	 */
	public static void main(String[] argv) {
		JFrame frame = new JFrame();
		try {
			
			String userAddress = (String) JOptionPane.showInputDialog(frame,
					"Server address", "Input server address",
					JOptionPane.PLAIN_MESSAGE, null, null, argv[0] + ":"
							+ argv[1]);

			String host = "";
			String port = "";
			try {
				StringTokenizer t = new StringTokenizer(userAddress, ":");
				host = t.nextToken();
				port = t.nextToken();				
			} catch (NullPointerException e) {
				System.exit(0);

			} catch (RuntimeException e) {
				System.out.println(e.toString());
				System.out.println("Address not valid. Use form host:port");
				System.exit(0);
			}
			
			host=host.trim();
			port=port.trim();
			
			String dest = "//" + host + ":" + port + "/drawingdrawing";			
			System.out.println("Connecting to " + dest);			

			DrawingServer drawingServer = (DrawingServer) Naming.lookup(dest);
			System.setSecurityManager(new RMISecurityManager());

			JPanel_DrawingDrawing drawingdrawing = new JPanel_DrawingDrawing();
			frame.getContentPane().add(drawingdrawing);
			frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			frame.pack();
			frame.setTitle("DrawingDrawing");
			frame.setSize(new Dimension(640, 480));
			frame.setJMenuBar(drawingdrawing.createJMenuBar());
			frame.setVisible(true);

			drawingdrawing.setDrawingServer(drawingServer);

		} catch (RemoteException re) {
			System.out.println(re.getMessage());
			JOptionPane.showMessageDialog(frame, "Connection error. Check if server is up on specyfied address.", "Error", JOptionPane.ERROR_MESSAGE);
			System.exit(-1);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

}
