package drawingserver;

import java.rmi.Remote;
import java.rmi.RemoteException;

import drawing.Curve;
import drawing.NoMoreLeftException;

/**
 * Interfejs serwera DrawingDrawing.
 * @author marek
 *
 */
public interface DrawingServer extends Remote{
	/**
	 * Zarejestruj klienta. Klient otrzymuje klucz sesji z ktrego korzysta przy wysyaniu
	 * narysowanych krzywych na serwer i odbieraniu krzywych dla niego przeznaczonych (tzn. takich,
	 * ktrych jeszcze nie ma).
	 * @return Klucz sesji
	 * @throws RemoteException
	 */
	public String register() throws RemoteException;
	/**
	 * Wylij krzyw na serwer.
	 * @param c Krzywa
	 * @throws RemoteException
	 */
	public void uploadCurve(Curve c) throws RemoteException;
	/**
	 * Odbierz krzyw z serwera. Jeli wszystkie zostay cignite, podnosi wyjtek NoMoreLeftException.
	 * @param clientID
	 * @return ciagnita krzywa
	 * @throws RemoteException
	 * @throws NoMoreLeftException
	 */
	public Curve downloadCurve(String clientID) throws RemoteException, NoMoreLeftException;
}
