package drawingserver;

import java.rmi.RemoteException;

import drawing.Curve;
import drawing.NoMoreLeftException;
/**
 * Implementacja serwera DrawingDrawing.
 *
 */
public class DrawingServerImplementation implements DrawingServer{
	/**
	 * Bank klientw.
	 */
	ClientsBank clientsBank = new ClientsBank();
		
	/**
	 * Konstruktor.
	 *
	 */
	public DrawingServerImplementation() {
		super();
		// TODO Auto-generated constructor stub
	}

	public String register() throws RemoteException {
		String id = clientsBank.newClient();
		return id;
	}

	public void uploadCurve(Curve c) throws RemoteException {
		try {
			if(c.getInstruction().equals("clear")){
				clientsBank.dropAllCurves();
				clientsBank.sendCurveToClients(c);
				System.out.println("Got clear from "+c.getAuthor());
				return;
			}
			
		} catch (NullPointerException e) {}
		
		clientsBank.saveAndSendCurveToClients(c);
	}

	public Curve downloadCurve(String clientID) throws RemoteException, NoMoreLeftException {
		return clientsBank.pollWaitingCurve(clientID);		
	}

}
