package drawingserver;

import java.io.File;
import java.rmi.Naming;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;

/**
 * Klasa do uruchamiania serwera. Jako argumenty przyjmuje adres hosta i
 * port na ktrym ma zosta uruchomiony rejestr RMI.
 */
public class DrawingServerLauncher {

	public DrawingServerLauncher() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public static void main(String[] argv){
		try{
            DrawingServerImplementation server = new DrawingServerImplementation();
            
            LocateRegistry.createRegistry(Integer.parseInt(argv[1]));
            UnicastRemoteObject.exportObject(server);
            
            String path = "//"+argv[0]+":"+argv[1]+"/drawingdrawing";            
            Naming.rebind(path, server);
                        
            System.out.println("DrawingDrawing server started at "+path);
        } catch(Exception e){        	
            e.printStackTrace();
        }
	}

}
